package com.sun.corba.se.impl.resolver;

import java.util.HashSet;
import java.util.Set;
import org.omg.CORBA.Object;
import org.omg.CORBA.portable.OutputStream;
import org.omg.CORBA.portable.RemarshalException;
import org.omg.CORBA.portable.ApplicationException;
import org.omg.CORBA.portable.InputStream;
import com.sun.corba.se.spi.ior.IORTemplate;
import com.sun.corba.se.spi.ior.iiop.IIOPProfileTemplate;
import com.sun.corba.se.spi.ior.ObjectKey;
import com.sun.corba.se.impl.orbutil.ORBUtility;
import com.sun.corba.se.spi.ior.IORFactories;
import com.sun.corba.se.spi.ior.iiop.IIOPFactories;
import com.sun.corba.se.spi.ior.iiop.GIOPVersion;
import com.sun.corba.se.spi.orb.ORB;
import com.sun.corba.se.impl.logging.ORBUtilSystemException;
import org.omg.CORBA.portable.Delegate;
import com.sun.corba.se.spi.resolver.Resolver;

public class BootstrapResolverImpl implements Resolver
{
    private Delegate bootstrapDelegate;
    private ORBUtilSystemException wrapper;
    
    public BootstrapResolverImpl(ORB orb, String s, int n) {
        this.wrapper = ORBUtilSystemException.get(orb, "orb.resolver");
        ObjectKey create = orb.getObjectKeyFactory().create("INIT".getBytes());
        IIOPProfileTemplate iiopProfileTemplate = IIOPFactories.makeIIOPProfileTemplate(orb, GIOPVersion.V1_0, IIOPFactories.makeIIOPAddress(orb, s, n));
        IORTemplate iorTemplate = IORFactories.makeIORTemplate(create.getTemplate());
        iorTemplate.add(iiopProfileTemplate);
        this.bootstrapDelegate = ORBUtility.makeClientDelegate(iorTemplate.makeIOR(orb, "", create.getId()));
    }
    
    private InputStream invoke(String s, String s2) {
        int i = 1;
        InputStream invoke = null;
        while (i != 0) {
            __Null _Null = null;
            i = 0;
            OutputStream request = this.bootstrapDelegate.request(_Null, s, true);
            if (s2 != null) {
                request.write_string(s2);
            }
            try {
                invoke = this.bootstrapDelegate.invoke(_Null, request);
            }
            catch (ApplicationException ex) {
                throw this.wrapper.bootstrapApplicationException(ex);
            }
            catch (RemarshalException ex2) {
                i = 1;
            }
        }
        return invoke;
    }
    
    public org.omg.CORBA.Object resolve(String s) {
        InputStream invoke = null;
        org.omg.CORBA.Object read_Object = null;
        try {
            invoke = this.invoke("get", s);
            read_Object = invoke.read_Object();
        }
        finally {
            this.bootstrapDelegate.releaseReply(null, invoke);
        }
        return read_Object;
    }
    
    public Set list() {
        InputStream invoke = null;
        HashSet<String> set = new HashSet();
        try {
            invoke = this.invoke("list", null);
            for (int read_long = invoke.read_long(), i = 0; i < read_long; ++i) {
                set.add(invoke.read_string());
            }
        }
        finally {
            this.bootstrapDelegate.releaseReply(null, invoke);
        }
        return set;
    }
}
